config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

  resources :activities, only: [:index, :create, :edit, :update, :destroy]

  resources :entries, only: [:create, :edit, :update, :destroy]
  get 'reports', to: 'entries#index'
  get 'tracking', to: 'entries#new'

  get 'main/about'
  get 'main/faq'

  resources :contacts, only: [:new, :create]

  devise_scope :user do
    authenticated :user do
      root 'entries#new', as: :authenticated_root
    end

    unauthenticated do
      root 'devise/sessions#new', as: :unauthenticated_root
    end
  end
end

app/models/activity.rb
class Activity < ApplicationRecord
  belongs_to :user
  has_many :entries
  validates :name, presence: true, uniqueness: { scope: [:user_id, :is_deleted] }

  scope :deleted, -> { where(is_deleted: true) }

  def soft_delete
    self.update_attribute :is_deleted, true
  end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true

  after_validation :log_validation_errors, if: :errors


  private

  def log_validation_errors
    Rails.logger.debug self.errors.full_messages.join("\n")
  end
end

app/models/contact.rb
class Contact < ActiveRecord::Base
  validates :name, :email, :message, presence: true
  after_create :send_email


  private
    def send_email
      ContactMailer.contact_email(self).deliver
    end
end

app/models/entry.rb
class Entry < ApplicationRecord
  belongs_to :activity
  validates :duration, presence: true, numericality: { greater_than: 0 }
  validates :date, presence: true

  # Added because user can enter time in hours/minutes/seconds, but :durations is stored in seconds
  attr_accessor :duration_hours, :duration_minutes, :duration_seconds
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable

  has_many :activities
  has_many :entries, through: :activities
end

app/controllers/activities_controller.rb
class ActivitiesController < ApplicationController
  before_action :authenticate_user!
  before_action :load_user_activity, only: [:edit, :update, :destroy]

  def index
    @activities = current_user.activities
    @activity = Activity.new
  end

  def create
    @activity = Activity.new(activity_params)
    @activity.user = current_user

    if @activity.save
      redirect_to activities_path, flash: { success: "Activity was added." }
    else
      flash.now[:error] = "There was an error creating the activity. #{@activity.errors.full_messages.to_sentence}."
      @activities = current_user.activities
      render "index"
    end
  end

  def edit
  end

  def update
    if @activity.update(activity_params)
      flash[:success] = "Activity was updated."
      redirect_to activities_path
    else
      flash.now[:error] = "There was an error updating the activity. #{@activity.errors.full_messages.to_sentence}."
      render "edit"
    end
  end

  def destroy
    if
      @activity.soft_delete
      redirect_to activities_path
    else
      flash.now[:error] = "There was an error deleting the activity."
      redirect_to activities_path
    end
  end


  private
    def activity_params
      params.require(:activity).permit(:name)
    end

    def load_user_activity
      @activity = current_user.activities.find(params[:id])
    end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/contacts_controller.rb
class ContactsController < ApplicationController
  def new
    @contact = Contact.new
  end

  def create
    @contact = Contact.new(contact_params)

    if @contact.save
      flash[:success] = "Thank you for your message!"
      redirect_to new_contact_path
    else
      render "new"
    end
  end


  private
    def contact_params
      params.require(:contact).permit(:name, :email, :message)
    end
end

app/controllers/entries_controller.rb
class EntriesController < ApplicationController
  before_action :authenticate_user!
  before_action :convert_params_to_proper_format, only: [:create, :update]
  before_action :load_user_entries, only: [:edit, :update, :destroy]
  before_action :load_user_activity, only: [:create]

  def index
    @entries = current_user.entries
    @date = params[:date].present? ? Date.strptime(params[:date], '%Y-%m-%d') : Date.current
    @entries_by_date = @entries.where(date: @date)
    @daily_sum = @entries_by_date.sum(:duration)
  end

  def new
    @activities = current_user.activities
    @entry = Entry.new(duration_hours: 0, duration_minutes: 0, duration_seconds: 0, date: Date.today)
  end

  def create
    @entry = Entry.new(entry_params)
    @entry.activity = @activity
    if @entry.save
      redirect_to tracking_path, flash: { success: "Entry was added." }
    else
      @activities = current_user.activities
      flash.now[:error] = "There was an error creating the entry."
      render "new"
    end
  end

  def edit
    # show duration to user in hours, minutes, and seconds
    @entry.duration_hours = "%02d" % (@entry.duration / 3600)
    @entry.duration_minutes = "%02d" % (@entry.duration / 60 % 60)
    @entry.duration_seconds = "%02d" % (@entry.duration % 60)
  end

  def update
    if @entry.update(entry_params)
      flash[:success] = "Entry was updated."
      redirect_to reports_path(date: @entry.date)
    else
      flash.now[:error] = "There was an error updating the entry. #{@entry.errors.full_messages.to_sentence}."
      render "edit"
    end
  end

  def destroy
    if @entry.destroy
      redirect_to reports_path(date: @entry.date)
    else
      flash.now[:error] = "There was an error deleting the entry."
      redirect_to reports_path(date: @entry.date)
    end
  end


  private
    def entry_params
      params.require(:entry).permit(:duration, :duration_hours, :duration_minutes, :duration_seconds, :date, :note)
    end

    def convert_params_to_proper_format
      if params[:entry][:date].present?
        params[:entry][:date] = Date.parse(params[:entry][:date]).strftime("%Y-%m-%d")
      end
      hours_in_seconds = params[:entry][:duration_hours].to_i * 3600
      minutes_in_seconds = params[:entry][:duration_minutes].to_i * 60
      params[:entry][:duration] = hours_in_seconds + minutes_in_seconds + params[:entry][:duration_seconds].to_i
    end

    def load_user_entries
      @entry = current_user.entries.find(params[:id])
    end

    # ensure that activity belongs to current user
    def load_user_activity
      @activity = current_user.activities.find(params[:entry][:activity_id])
    end
end

app/controllers/main_controller.rb
class MainController < ApplicationController
  def about
  end

  def faq
  end
end

app/helpers/activities_helper.rb
module ActivitiesHelper
end

app/helpers/application_helper.rb
module ApplicationHelper
  def bootstrap_class_for_alert(alert_type)
    { success:  "alert-success", alert: "alert-warning", notice: "alert-info", error: "alert-danger" }[alert_type]
  end
end

app/helpers/contacts_helper.rb
module ContactsHelper
end

app/helpers/entries_helper.rb
module EntriesHelper
  def seconds_to_time(seconds)
    hours = seconds / 3600
    minutes = seconds / 60 % 60
    seconds = seconds % 60

    ['%02d' % hours, '%02d' % minutes, '%02d' % seconds].join(":")
  end
end

app/helpers/home_helper.rb
module HomeHelper
end

app/views/activities/edit.html.erb
<div class="container medium-margin-top activity">
  <div class="row">
    <div class="col-md-4 col-centered">
      <h2>Update activity</h2>
      <%= form_for @activity do |f| %>
        <div class="field medium-margin-top ">
          <%= f.text_field :name, class: "small-margin-bottom full-width" %>
        </div>
        <%= f.submit "Update", class: "btn btn-secondary btn-sm full-width" %>
      <% end %>
    </div>
  </div>
</div>

app/views/activities/index.html.erb
<div class="container medium-margin-top activity">
  <div class="row">
    <div class="col-md-4 col-centered">
      <h1 class="small-margin-bottom">Your activities</h1>

      <% if current_user.activities.present? %>
        <ul class="list-unstyled">
          <% @activities.each do |activity| %>
            <% if !activity.is_deleted? %>
              <li>
                <div class="row">
                  <div class="col-md-8">
                    <%= activity.name %>
                  </div>
                  <div class="col-md-1">
                    <%= link_to "<i class='far fa-edit'></i>".html_safe, edit_activity_path(activity) %>
                  </div>
                  <div class="col-md-1">
                    <%= link_to "<i class='far fa-trash-alt'></i>".html_safe, activity_path(activity),
                        method: :delete, data: { confirm: "Are sure you want to delete this activity?" } %>
                  </div>
                </div>
              </li>
            <% end %>
          <% end %>
        </ul>
      <% else %>
        <p>Your list of activities is empty.</p>
      <% end %>

      <%= form_for @activity do |f| %>
        <div class="row">
          <div class="col-md-8">
            <%= f.text_field :name%>
          </div>
          <div class="col-md-4">
            <%= f.submit "Add", class: "btn btn-secondary btn-sm smaller" %>
          </div>
        </div>
      <% end %>
    </div>
  </div>
</div>

app/views/contacts/new.html.erb
<div class="container medium-margin-top">
  <div class="row">
    <div class="col-md-4 offset-md-4">
      <h1>Contact form</h1>
      <p class="justify">Fill out the fields below and I'll get back to you shortly!</p>
      <div class="form contact-form">
        <% if @contact.errors.any? %>
          <div class="small-margin-bottom alert alert-danger">There was an issue sending your message: <%= @contact.errors.full_messages.map(&:inspect).join('. ') %>.</div>
        <% end %>

        <%= form_for @contact do |f| %>
          <div class="field">
            <%= f.label :name %><br />
            <%= f.text_field :name, class: "small-margin-bottom", placeholder: "Your name" %>
          </div>

          <div class="field">
            <%= f.label :email %><br />
            <%= f.email_field :email, class: "small-margin-bottom", placeholder:"email@example.com" %>
          </div>

          <div class="field">
            <%= f.label :message %><br />
            <%= f.text_area :message, size: "40x5", class: "small-margin-bottom", placeholder: "Hi Natalia..." %>
          </div>

          <%= f.submit "Submit", class: "btn btn-secondary btn-sm" %>
        <% end %>
      </div>
    </div>
  </div>
</div>

app/views/entries/edit.html.erb
<div class="container medium-margin-top">
  <div class="row">
    <div class="col-md-4 offset-md-4">
      <h2>Editing</h2>
      <h3 class="thicker">Activity: <%= @entry.activity.name %></h3>

      <%= form_for @entry do |f| %>

        <span class="field timer">
          <%= f.text_field :duration_hours, id: "duration-hours", maxlength: 2 %>
          <span class="timer">:</span>
          <%= f.text_field :duration_minutes, id: "duration-minutes", maxlength: 2 %>
          <span class="timer">:</span>
          <%= f.text_field :duration_seconds, id: "duration-seconds", maxlength: 2 %>
        </span>

        <div class="field">
          <%= f.label :date %><br />
          <%= f.text_field :date, class: "small-margin-bottom full-width" %>
        </div>

        <div class="field">
          <%= f.label :note %><br />
          <%= f.text_area :note, class: "small-margin-bottom full-width additional-note-field" %>
        </div>
        <%= f.submit "Update", class: "btn btn-secondary btn-sm full-width" %>
      <% end %>
    </div>
  </div>
</div>

app/views/entries/index.html.erb
<% content_for(:flash_columns) { "12" } %>

<div class="container medium-margin-top">
  <div class="row">
    <div class="col-md-5">
      <div data-provide="datepicker-inline" data-date-max-view-mode="days" id="date-picker"></div>
      <%= form_tag(reports_path, method: :get, id: "date-form") do %>
        <%= hidden_field_tag(:date, @date, id: "date-field") %>
      <% end %>
    </div>

    <div class="col-md-7">
      <h1 class="small-margin-bottom">Entries for <%= @date %></h1>
      <ul class="list-unstyled entry-list">
        <% if @entries_by_date.present? %>
          <% @entries_by_date.each do |entry| %>
            <li>
              <div class="row">
                <div class="col-md-8">
                  <%= entry.activity.name %>
                  <% if entry.note.present? %>
                    <i class="far fa-sticky-note" data-toggle="collapse" data-target="#entry-note-<%=entry.id %>"></i>
                    <div id="entry-note-<%=entry.id %>" class="collapse note">
                      <%= entry.note %>
                    </div>
                  <% end %>
                </div>
                <div class="col-md-2">
                  <%= seconds_to_time(entry.duration) %>
                </div>
                <div class="col-md-1">
                  <%= link_to "<i class='far fa-edit'></i>".html_safe, edit_entry_path(entry) %>
                </div>
                <div class="col-md-1">
                  <%= link_to "<i class='far fa-trash-alt'></i>".html_safe, entry_path(entry),
                      method: :delete, data: { confirm: "Are sure you want to delete this activity?" } %>
                </div>
              </div>
            </li>
            <hr />
          <% end %>
          <div class="row">
            <div class="col-md-8">
              Total time:
            </div>
            <div class="col-md-4">
              <%= seconds_to_time(@daily_sum) %>
            </div>
          </div>
        <% else %>
          <p>List of entries for that date is empty.</p>
        <% end %>
      </ul>
    </div>
  </div>
</div>

app/views/entries/new.html.erb
<div class="container tracking medium-margin-top">
  <div class="row">
    <div class="col-md-4 col-centered">
      <h1>Select an activity</h1>
      <%= form_for @entry do |f| %>

        <%# http://api.rubyonrails.org/classes/ActionView/Helpers/FormOptionsHelper.html#method-i-select %>
        <%#= f.select(:activity_id, options_from_collection_for_select(@activities, :id, :name, @entry.activity_id), { include_blank: true }) %>
        <%= f.select(:activity_id, @activities.where(is_deleted: false).map { |a| [a.name, a.id] }, { include_blank: true }, class: "small-margin-bottom") %>

        <h1>Start timing</h1>
        <div id="duration-timer">
          <span class="field timer">
            <%= f.text_field :duration_hours, id: "duration-hours", maxlength: 2 %>
            <span class="timer">:</span>
            <%= f.text_field :duration_minutes, id: "duration-minutes", maxlength: 2 %>
            <span class="timer">:</span>
            <%= f.text_field :duration_seconds, id: "duration-seconds", maxlength: 2 %>
          </span>

          <button id="start-button" type="button"><i class="far fa-play-circle"></i></button>
          <button id="stop-button" type="button"><i class="far fa-stop-circle"></i></button>
        </div>
        <div class="field">
          <%= f.label :date, "Pick a date" %><br />
          <%= f.text_field :date, class: "small-margin-bottom", data: { "provide" => "datepicker", "date-max-view-mode" => "days" }, id: "date-picker-autoclose" %>
        </div>
        <div class="field">
          <%= f.label :note, "Add a note (optional)" %><br />
          <%= f.text_area :note, class: "small-margin-bottom additional-note-field" %>
        </div>
        <%= f.submit "Add", class: "small-margin-bottom btn btn-secondary btn-sm", id: "duration-timer-submission" %>
      <% end %>
    </div>
  </div>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>TimeBucket</title>
    <%= csrf_meta_tags %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>

    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <script defer src="https://use.fontawesome.com/releases/v5.0.6/js/all.js"></script>

    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=0" />
  </head>

  <body>
    <nav class="navbar navbar-expand-lg navbar-light bg-light">
      <% if user_signed_in? %>
        <%= link_to "Time Bucket", tracking_path, class: "navbar-brand" %>
      <% else %>
        <%= link_to "Time Bucket", main_about_path, class: "navbar-brand" %>
      <% end %>
      <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
      </button>
      <div class="collapse navbar-collapse" id="navbarNav">
        <ul class="navbar-nav">
          <% if user_signed_in? %>
            <li class="nav-item">
              <%= link_to "Activities", activities_path, class: current_page?(activities_path) ? "active" : "" %>
            </li>
            <li class="nav-item">
              <%= link_to "Tracking", tracking_path, class: current_page?(tracking_path) ? "active" : "" %>
            </li>
            <li class="nav-item">
              <%= link_to "Reports", reports_path, class: current_page?(reports_path) ? "active" : "" %>
            </li>
            <li class="nav-item">
              <%= link_to "Profile Management", edit_user_registration_path, class: current_page?(edit_user_registration_path) ? "active" : "" %>
            </li>
            <li class="nav-item">
              <%= link_to "Logout", destroy_user_session_path, method: :delete, class: current_page?(destroy_user_session_path) ? "active" : "" %>
            </li>
          <% else %>
            <li class="nav-item text-righ">
              <%= link_to "Login", new_user_session_path, class: current_page?(new_user_session_path) ? "active" : "" %>
            </li>
            <li class="nav-item text-righ pull-right">
              <%= link_to "Sign up", new_user_registration_path, class: current_page?(new_user_registration_path) ? "active" : "" %>
            </li>
          <% end %>
        </ul>
      </div>
    </nav>

    <div class="container medium-margin-top">
      <div class="row">
        <% flash_columns = content_for?(:flash_columns) ? yield(:flash_columns) : "4" %>
        <div class="col-md-<%= flash_columns %> col-centered">
          <% [:success, :alert, :notice, :error].each do |type| %>
            <% if flash[type].present? %>
              <div class="alert <%= bootstrap_class_for_alert(type) %> alert-dismissible fade show" role="alert"><%= flash[type] %>
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
            <% end %>
          <% end %>
        </div>
      </div>
    </div>

    <%= yield %>

    <footer class="container-fluid">
      <div class="row">
        <div class="col-sm-5 offset-5">
          <%= link_to "About", main_about_path, class: current_page?(main_about_path) ? "active" : "" %>
          <%= link_to "Contact", new_contact_path, class: current_page?(new_contact_path) ? "active" : "" %>
          <%= link_to "FAQ", main_faq_path, class: current_page?(main_faq_path) ? "active" : "" %>
        </div>
        <div class="col-sm-2 text-right">
          <span>&copy; Natalia Barańska, <%= Time.current.year %></span>
        </div>
      </div>
    </footer>
  </body>
</html>

app/views/main/about.html.erb
<div class="container about medium-margin-top">
  <div class="row">
    <div class="col-md-8 col-centered">
      <h1>Welcome to Time Bucket!</h1>

      <h3 class="medium-margin-top justify">Time Bucket is a simple tool to help you keep track of your time.</h3>

      <p class="medium-margin-top justify">If you want to learn more, check out the <%= link_to "FAQ", main_faq_path, class: "underline" %> section. If you still have any questions you can contact me direcly by cliking <%= link_to "here", new_contact_path, class: "underline" %> and dropping me a message.</p>
      <% if !user_signed_in? %><p>To get started, click <%= link_to "here", new_user_registration_path, class: "underline" %> to create an account.</p><% end %>
      <p class="justify">Bear in mind that Time Bucket is still a work in progress. I am planning to add more features soon. If you have any enhancement ideas on your mind, don't hesitate to share them with me.</p>

      <p class="text-right medium-margin-top">Enjoy time tracking with Time Bucket.<p>
      <p class="text-right">–– Natalia</p>
    </div>
  </div>
</div>

app/views/main/faq.html.erb
<div class="container faq medium-margin-top">
  <div class="row">
    <div class="col-md-8 col-centered">
    <h1>FAQ</h1>
      <div class="justify">
        <h3>What is Time Bucket?</h3>
        <p class="small-margin-bottom">It is a simple tool to track your time using either an automated timer or manual entries. It allows you to track time for any activity or project. <% if !user_signed_in? %>To get started, click <%= link_to "here", new_user_registration_path, class: "underline" %> to create an account.</p><% end %>

        <h3>How do I use it?</h3>
        <p class="small-margin-bottom">It is simple. Enter a name of an activity you wish to track, and add it to your list. Once you have done so, simply choose the activity to track from you list, and start the timer. If you wish, you may enter the time manually instead.</p>

        <h3>Is it free to use?</h3>
        <p class="small-margin-bottom">Yes, there is absolutely no subscription fee. Time Bucket is 100% free.</p>

        <h3>Are you planning any future enhancements?</h3>
        <p class="small-margin-bottom">Yes. Some ideas:</p>
        <ul>
          <li>ability to set goals</li>
          <li>reports</li>
          <li>ability to re-order list of activities</li>
        </ul>

        <h3>Can I delete my account?</h3>
        <p>Yes. After creating an account you can delete it in a Profile Management section.</p>

        <h3>Who are you?</h3>
        <p class="small-margin-bottom">My name is Natalia. I am a self-taught programmer who likes to make web applications, mostly in Ruby on Rails.</p>

        <hr class="medium-margin-top"/>

        <p class="small-margin-bottom">You have any questions, problems, suggestions, found a bug? Drop me a <%= link_to "message", new_contact_path, class: "underline" %>.</p>
      </div>
    </div>
  </div>
</div>